C H. K. D. H. Bhadeshia, January 2024
C Queen Mary University of London
C University of Cambridge
C Growth of austenite in pearlite
C
           IMPLICIT REAL*8(A-H,K,O-Z), INTEGER(I)
C DIFFUSION COEFFICIENTS FOR CARBON metres squared per second
C   FOR A TEMPERATURE OF 750 CELSIUS           
           DGAMMA=0.16D-11
           DALPHA=0.16D-9
C CONCENTRATION TERMS IN MOLE FRACTIONS
C xga is x-gamma-alpha. xag is x-alpha-gamma
C xtg is x-theta-gamma xgt is x-gamma-theta
C XA IS THE CONCENTRATION IN THE SUPERHEATED FERRITE
           
           XGA=0.0060394
           XAG=0.0001672
           XTG=0.0668943
           XGT=0.0081871
            XA=0.0002
C 
C SI IS INTERLAMELLAR SPACING IN METRES
           SI=0.4D-6
           ZSTAR=SI*(6.67-0.76)/(6.67-0.02)
           ZT=SI*(0.76-0.02)/(6.67-0.02)
           ZA=ZT+0.1*ZT
           WRITE(*,2) ZT,ZA, ZSTAR
           WRITE(*,3)

           DO I=1,100
             THETARATE=-DGAMMA*(XGA-XGT)/((ZA-ZT)*(XTG-XGT))
             ALPHARATE=DALPHA*(XA-XAG)/((ZSTAR-ZA)*(XGA-XAG))
             TIME=0.0001D+00*I
             ZT=ZT-THETARATE*TIME
             ZA=ZA+ALPHARATE*TIME
             IF(ZA .GE. ZSTAR) THEN 
               STOP
             ENDIF
             IF(ZT<0) THEN 
               ZT=0
             ENDIF  
             WRITE(*,1) TIME, ZT,ZA
           END DO
           
1          FORMAT(F8.4,D12.4,3D12.4)
2          FORMAT('  INITIAL VALUES: ZT',D12.4,' ZA',D12.4,
     &      '    ZSTAR ',D12.4)
3          FORMAT('TIME / s   ZT / m     ZA / m')
           STOP
           end